require "advanced"

include AdvancedDCL
include Math

n = 100
x = Array.new(n)
y = Array.new(n)

#---------------------------- DATA DEFINITION --------------------------
r = 0.2
a = 3.6
r0 = 0.0
for i in 0..n-1
  r = a*r*(1.0-r)
  r0 = r0 + r*4 - 2.58
  x2 = (i-49)**2
  rexp = 4.0*(i+1)/n
  x[i] = 10**rexp
  y[i] = 1.0e5*exp(-x2) + 10.0**r0
end
y[19] = 1.0e4
y[39] = 2.0e3
y[64] = 3.0e4
y[69] = 5.0e2

#----------------------------- GRAPH -----------------------------------
devopen("X")

Frame.new
Fig.transnum=4

Fig.inclpoint=[x, y]

Axis.daxs
Plot.udraw(x, y)

devclose

#-----------------------------------------------------------------------
