require "fig"
#require "axis"

module AdvancedDCL
  module Axis
    module Lin
      def param_init
	@param = Parameter.new(Axis.param)
	@param.init("uxuser", Float, "uzrset", "uzrget", 0, 0)
	@param.init("uyuser", Float, "uzrset", "uzrget", 0, 0)
	
	@param.init("labelxb", TrueClass, "uzlset", "uzlget", 0, 0)
	@param.init("labelxt", TrueClass, "uzlset", "uzlget", 0, 0)
	@param.init("labelxu", TrueClass, "uzlset", "uzlget", 0, 0)
	@param.init("labelyl", TrueClass, "uzlset", "uzlget", 0, 0)
	@param.init("labelyr", TrueClass, "uzlset", "uzlget", 0, 0)
	@param.init("labelyu", TrueClass, "uzlset", "uzlget", 0, 0)
	
	@param.init("irotlxb", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("irotlxt", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("irotlxu", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("irotlyl", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("irotlyr", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("irotlyu", Fixnum, "uziset", "uziget", 0, 0)
	
	@param.init("irotcxb", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("irotcxt", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("irotcxu", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("irotcyl", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("irotcyr", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("irotcyu", Fixnum, "uziset", "uziget", 0, 0)
	
	@param.init("icentxb", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("icentxt", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("icentxu", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("icentyl", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("icentyr", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("icentyu", Fixnum, "uziset", "uziget", 0, 0)
	
	@param.init("indext0", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("indext1", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("indext2", Fixnum, "uziset", "uziget", 0, 0)
	
	@param.init("indexl0", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("indexl1", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("indexl2", Fixnum, "uziset", "uziget", 0, 0)
	
	@param.init("rsizet0", Float, "uzrset", "uzrget", 0, 0)
	@param.init("rsizet1", Float, "uzrset", "uzrget", 0, 0)
	@param.init("rsizet2", Float, "uzrset", "uzrget", 0, 0)
    
	@param.init("rsizel0", Float, "uzrset", "uzrget", 0, 0)
	@param.init("rsizel1", Float, "uzrset", "uzrget", 0, 0)
	@param.init("rsizel2", Float, "uzrset", "uzrget", 0, 0)
	
	@param.init("rsizec0", Float, "uzrset", "uzrget", 0, 0)
	@param.init("rsizec1", Float, "uzrset", "uzrget", 0, 0)
	@param.init("rsizec2", Float, "uzrset", "uzrget", 0, 0)
	
	@param.init("loffset", TrueClass, "uzlset", "uzlget", 0, 0)
	@param.init("xoffset", Float, "uzrset", "uzrget", 0, 0)
	@param.init("yoffset", Float, "uzrset", "uzrget", 0, 0)
	@param.init("xfact", Float, "uzrset", "uzrget", 0, 0)
	@param.init("yfact", Float, "uzrset", "uzrget", 0, 0)

	@param.init("pad1", Float, "uzrset", "uzrget", 0, 0)
	@param.init("pad2", Float, "uzrset", "uzrget", 0, 0)

	@param.init("iflag", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("lbtwn", TrueClass, "uzlset", "uzlget", 0, 0)
	@param.init("rbtwn", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("lbound", TrueClass, "uzlset", "uzlget", 0, 0)
	@param.init("lbmsg", TrueClass, "uzlset", "uzlget", 0, 0)
	@param.init("inner", Fixnum, "uziset", "uziget", 0, 0)
	@param.init("rundef", Float, "uzrset", "uzrget", 0, 0)

	@param.init("cxfmt", String, "uzcset", "uzcget", 0, 0)
	@param.init("cyfmt", String, "uzcset", "uzcget", 0, 0)
	
	@param.init("roffxu", Float, "uzrset", "uzrget", 0, 0)
	@param.init("roffyu", Float, "uzrset", "uzrget", 0, 0)
	@param.init("rofgxb", Float, "uzrset", "uzrget", 0, 0)
	@param.init("rofgxt", Float, "uzrset", "uzrget", 0, 0)
	@param.init("rofgxu", Float, "uzrset", "uzrget", 0, 0)
	@param.init("rofgyl", Float, "uzrset", "uzrget", 0, 0)
	@param.init("rofgyr", Float, "uzrset", "uzrget", 0, 0)
	@param.init("rofgyu", Float, "uzrset", "uzrget", 0, 0)
	
	@param.init("roffxt", Float, "uzrset", "uzrget", 0, 0)
	@param.init("roffxb", Float, "uzrset", "uzrget", 0, 0)
	@param.init("roffyl", Float, "uzrset", "uzrget", 0, 0)
	@param.init("roffyr", Float, "uzrset", "uzrget", 0, 0)
	@param.init("iundef", Fixnum, "uziset", "uziget", 0, 0)

	@temp_param = @param.dup
      end
      
      private :param_init

#------------------- method for parameters----------------------

      def set(key, val)
	@param[key] = val
      end  
    
#----------------------------------------------------------
#------------ draw method ----------------------

      def xaxdv(cside, dx1, dx2, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync
	
	Fig.settrf

	DCL.uxaxdv(cside, dx1, dx2)
	@backup.sync
	@temp_param.clear
      end
      
      def yaxdv(cside, dy1, dy2, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync
	
	Fig.settrf
		
	DCL.uyaxdv(cside, dy1, dy2)
	@backup.sync
	@temp_param.clear
      end
      
      def xaxlb(cside, ux1, ux2, ch, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync
	
	Fig.settrf
	
	nc = 1
	ch.each{|i|
	  if(i.type != String)
	    raise ArgumentError, "elements of the 4th argument must be String"
	  end
	  
	  if(i.length > nc)
	    nc = i.length
	  end
	}
	
	DCL.uxaxlb(cside, ux1, ux1.length, ux2, ch, nc, ux2.length)
	@backup.sync
	@temp_param.clear
      end
      
      def yaxlb(cside, uy1, uy2, ch, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync
	
	Fig.settrf
	
	nc = 1
	ch.each{|i|
	  if(i.type != String)
	    raise ArgumentError, "elements of the 4th argument must be String"
	  end
	  
	  if(i.length > nc)
	    nc = i.length
	  end
	}
	
	DCL.uyaxlb(cside, uy1, uy1.length, uy2, ch, nc, uy2.length)
	@backup.sync
	@temp_param.clear
      end
      
      def xpaxs(cside, islct, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync
	
	Fig.settrf
	
	DCL.uxpaxs(cside, islct)
	@backup.sync
	@temp_param.clear
      end
      
      def ypaxs(cside, islct, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync
	
	Fig.settrf
	
	DCL.uypaxs(cisde, islct)
	@backup.sync
	@temp_param.clear
      end
      
      def xplbl(cside, islct, ux, ch, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync
	
	Fig.settrf
		
	nc = 1
	ch.each{|i|
	  if(i.type != String)
	    raise ArgumentError, "elements of the 4th argument must be String"
	  end
	  
	  if(i.length > nc)
	    nc = i.length
	  end
	}
	
	DCL.uxplbl(cside, islct, ux, ch, nc, ux.length)
	@backup.sync
	@temp_param.clear
      end
      
      def yplbl(cside, islct, uy, ch, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync
	
	Fig.settrf
		
	nc = 1
	ch.each{|i|
	  if(i.type != String)
	    raise ArgumentError, "elements of the 4th argument must be String"
	  end
	  
	  if(i.length > nc)
	    nc = i.length
	  end
	}
	
	DCL.uyplbl(cside, islct, uy, ch, nc, uy.length)
	@backup.sync
	@temp_param.clear
      end
      
      def xpnum(cside, islct, ux, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync
	
	Fig.settrf
		
	DCL.uxpnum(cside, islct, ux, ux.length)
	@backup.sync
	@temp_param.clear
      end
      
      def ypnum(cside, islct, uy, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync

	Fig.settrf
		
	DCL.uypnum(cside, islct, uy, uy.length)
	@backup.sync
	@temp_param.clear
      end
      
      def xptmk(cside, islct, ux, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync

	Fig.settrf
	
	DCL.uxptmk(cside, islct, ux, ux.length)
	@backup.sync
	@temp_param.clear
      end
      
      def yptmk(cside, islct, uy, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync
	
	Fig.settrf
		
	DCL.uyptmk(cside, islct, uy, uy.length)
	@backup.sync
	@temp_param.clear
      end
      
      def xpttl(cside, islct, cttl, px, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync
	
	Fig.settrf
		
	DCL.uxpttl(cside, islct, cttl, px)
	@backup.sync
	@temp_param.clear
      end
      
      def ypttl(cside, islct, cttl, py, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync

	Fig.settrf
		
	DCL.uypttl(cside, islct, cttl, py)
	@backup.sync
	@temp_param.clear
      end

      def xmttl(cside, cttl, px, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync
	
	Fig.settrf
	
	DCL.uxmttl(cside, cttl, px)
	@backup.sync
	@temp_param.clear
      end
    
      def ymttl(cside, cttl, py, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync

	Fig.settrf
	
	DCL.uymttl(cside, cttl, py)
	@backup.sync
	@temp_param.clear
      end
      
      def xsttl(cside, cttl, px, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync
	
	Fig.settrf
	
	DCL.uxsttl(cside, cttl, px)
	@backup.sync
	@temp_param.clear
      end
    
      def ysttl(cside, cttl, py, temp=false)
	@param.sync
	@backup = @temp_param.set(temp, @param)
	@temp_param.sync
	
	Fig.settrf
		
	DCL.uysttl(cside, cttl, py)
	@backup.sync
	@temp_param.clear
      end

      def xsaxs(cside)
	DCL.uxsaxs(cside)
      end

      def ysaxs(cside)
	DCL.uysaxs(cside)
      end

      module_function :param_init
      module_function :set
      module_function :xaxdv
      module_function :yaxdv
      module_function :xaxlb
      module_function :yaxlb
      module_function :xpaxs
      module_function :ypaxs
      module_function :xplbl
      module_function :yplbl
      module_function :xpnum
      module_function :ypnum
      module_function :xptmk
      module_function :yptmk
      module_function :xpttl
      module_function :ypttl
      module_function :xmttl
      module_function :ymttl
      module_function :xsttl
      module_function :ysttl
      module_function :xsaxs
      module_function :ysaxs

      param_init

      @param.keys.each{|i|
	eval "def #{i}; @param['#{i}']; end"
	eval "def #{i}=(val); set('#{i}', val); end"
      }
      
      @param.keys.each{|i|
	eval "module_function :#{i}"
	eval "module_function :#{i}="
      }
    end
  end
end
