require "num/numarray"
require "advanced"

include AdvancedDCL
include Math

upx3 = NumArray.span(Float, 3)
upy3 = NumArray.span(Float, 3)
upx6 = NumArray.span(Float, 6)
upy6 = NumArray.span(Float, 6)
upxs = NumArray.span(Float, 61)
upys = NumArray.span(Float, 61)

a = 0.8
th = PI * 2 / 3
upx3 = a * ((th * (upx3+1)).sin)
upy3 = a * ((th * (upx3+1)).cos)

th = PI * 2 / 6
upx6 = a * ((th * (upx6+1)).sin)
upy6 = a * ((th * (upx6+1)).cos)

th = PI * 4 / 60
upxs = (upxs - 30) * a / 30
upys = a * ((th * upys).sin)

devopen("X")

Tone.lsoftf(true)
Frame.new

Fig.window(-1.0, 1.0, -1.0, 1.0)
FIg.viewport(0.0, 0.5, 0.0, 0.5)
Fig.transnum(1)

Plot.udraw(upx3, upy3)
Tone.udraw(upx3, upy3)

Fig.viewport(0.0, 0.5, 0.5, 1.0)
Tone.tonepat(101)
Tone.udraw(upx6, upy6)

Fig.viewport(0.5, 1.0, 0.0, 0.5)
Tone.udrawz(upx6, upy6, 201)

Fig.viewport(0.5, 1.0 ,0.5, 1.0)
Tone.udrawz(upxs, upys, 601)

devclose 
