require "advanced"

include AdvancedDCL

x = [-7.5, 7.5, 7.5, -7.5, -7.5]
y = [-7.5, -7.5, 7.5, 7.5, -7.5]

devopen("X")

xmaxf = 26.0
ymaxf = 18.5

Frame.form(xmaxf, ymaxf)
Frame.rat(xmaxf, ymaxf)

Frame.set("lfull", true)
Frame.new

Fig.window=[-xmaxf/2.0, xmaxf/2.0, -ymaxf/2.0, ymaxf/2.0]
p Fig.window
Plot.udraw(x, y)
Text.udrawz(0.0, 0.0, "15cm "+DCL.csgi(194)+" 15cm", 0.05, 0, 0, 3)

devclose 
